import { createProgressGuard, createLogGuard, createStackGuard } from 'utils4u/vue-router';
import { createRouter, createWebHistory, type Router } from 'vue-router';
import { routes, handleHotUpdate } from 'vue-router/auto-routes';
console.debug(`routes :>> `, JSON.stringify(routes, null, 2));

export const router = createRouter({
  history: createWebHistory(import.meta.env.BASE_URL),
  routes,
  strict: true,
});

if ($__DEV__) Object.assign(window, { router });

setupRouterGuard(router);

// Don't change the order of creation
function setupRouterGuard(router: Router) {
  createProgressGuard(router);
  createLogGuard(router);
  Object.assign(window, { stack: createStackGuard(router) });

  router.onError((error) => {
    console.debug('🚨 [router error]: ', error);
  });
}

if (import.meta.hot) {
  handleHotUpdate(router);
}
